-- by modelleicher
-- www.schwabenmodding.bplaced.net

Allrad_mp = {};

function Allrad_mp.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Allrad_mp:load(xmlFile)

	self.AllradActive = false;
	 
	self.wellenSpeed = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Allradwellen.Wellen#Speed"), 1);
	self.wellenCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Allradwellen.Wellen#count"), 0);	 
	self.Wellen = {}
	if self.wellenCount ~= 0 then
	    for i=1, self.wellenCount do
	        local Welle = string.format("vehicle.Allradwellen.Welle%d", i)
		    self.Wellen[i] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, Welle .. "#index"));
	    end;
	end;
	
	self.hudAPos = {};
	self.hudAPos.X = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Allradwellen#HudPosX"),0.85);
	self.hudAPos.Y = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Allradwellen#HudPosY"),0.22);
    self.hudAWidth = 0.08;
    self.hudAHeight = 0.08;
	self.hudAPath = Utils.getFilename("allrad_symbol.png", self.baseDirectory);
	self.hudAOverlay = Overlay:new("hudAOverlay", self.hudAPath, self.hudAPos.X, self.hudAPos.Y, self.hudAWidth, self.hudAHeight);
	self.showhudA = false;
	
end;

function Allrad_mp:delete()
    if self.hudAOverlay ~= nil then
		self.hudAOverlay:delete();
	end;	
end;

function Allrad_mp:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Allrad_mp:keyEvent(unicode, sym, modifier, isDown)
end;

function Allrad_mp:update(dt)

    if self:getIsActiveForInput() then
    
		if InputBinding.hasEvent(InputBinding.ALLRAD_MP) then
		   	self.AllradActive = not self.AllradActive;
		end;
	
   		if self.AllradActive == true then
			self.showhudA = true;		
			self.wheels[1].driveMode =2
		 	self.wheels[2].driveMode =2
		 	self.wheels[3].driveMode =2
		 	self.wheels[4].driveMode =2			
		else
			self.showhudA = false;
		 	self.wheels[1].driveMode =0
			self.wheels[2].driveMode =0
			self.wheels[3].driveMode =2
			self.wheels[4].driveMode =2			
		end; 		
	end;	
	
    if self:getIsActiveForInput() then
	   if self.wellenCount ~= 0 then
	      local getRx, getRy, getRz = getRotation(self.wheels[3].repr);
		  local rWert = getRx * self.wellenSpeed
	      for i=1, self.wellenCount do
	         setRotation(self.Wellen[i], 0, 0, getRx);
	      end;
	   end;
    end;		  
	  
end;

function Allrad_mp:draw()
      if self.AllradActive then
	 g_currentMission:addExtraPrintText("Taste 7:  Allrad ausschalten");
	else
	 g_currentMission:addExtraPrintText("Taste 7:  Allrad einschalten");
	end;
	  if self.showhudA and self.isEntered then
		self.hudAOverlay:render();
	end;
end;

